Title: Computations over Distributed Data without Aggregation
Maintainer: Balasubramanian Narasimhan <naras@stat.Stanford.EDU>
Package: distcomp
Version: 1.1
VignetteBuilder: knitr
URL: http://dx.doi.org/10.18637/jss.v077.i13
Depends: survival, stats, R (>= 3.1.0)
Imports: utils, shiny, httr (>= 1.0.0), digest, jsonlite, stringr, R6
        (>= 2.0)
Suggests: opencpu, knitr, covr
Authors@R: c(person("Balasubramanian", "Narasimhan", role=c("aut", "cre"),
	   	   email = "naras@stat.Stanford.EDU"),
           person("Marina", "Bendersky", role=c("aut")),
           person("Sam", "Gross", role=c("aut")),
	   person(c("Terry", "M."), "Therneau", role=c("ctb")),
           person("Thomas", "Lumley", role=c("ctb")))
Description: Implementing algorithms and fitting models when sites (possibly remote) share
  computation summaries rather than actual data over HTTP with a master R process (using
  'opencpu', for example). A stratified Cox model and a singular value decomposition are
  provided. The former makes direct use of code from the R 'survival' package. (That is,
  the underlying Cox model code is derived from that in the R 'survival' package.)
  Sites may provide data via several means: CSV files, Redcap API, etc. An extensible
  design allows for new methods to be added in the future and includes facilities
  for local prototyping and testing. Web applications are provided (via 'shiny') for
  the implemented methods to help in designing and deploying the computations.
Copyright: inst/COPYRIGHTS
Encoding: UTF-8
License: LGPL (>= 2)
RoxygenNote: 6.1.1
NeedsCompilation: yes
Packaged: 2019-09-23 18:32:37 UTC; naras
Author: Balasubramanian Narasimhan [aut, cre],
  Marina Bendersky [aut],
  Sam Gross [aut],
  Terry M. Therneau [ctb],
  Thomas Lumley [ctb]
Repository: CRAN
Date/Publication: 2019-09-23 18:50:03 UTC
Built: R 3.6.3; x86_64-w64-mingw32; 2020-10-18 20:30:04 UTC; windows
Archs: x64

## About the contents of this directory

This directory contains the two examples discussed in the paper, along
with the data and transcripts of R sessions. They are provided for
reference.

### Update on version 0.25.4

Version 0.25.1 of `distcomp` relied on imports from `httr` version
below 0.6.x. Since then, package `httr` has been updated to version
1.x using a new `curl` library and `distcomp` has now been updated to
account for them. The changes are pretty minor but the parameters for
the `httr::POST` requests that `distcomp` makes are different: the SSL
options are now named with underscores and the parameter values are
now not `logical` but `integer`, with `0L` for `FALSE` and `1L` for
`TRUE`. All our examples work as before (see the examples in the `doc`
directory). The transcripts here have been updated for version 0.25.4
of `distcomp` with session information along with some improvements.

## Table of Contents


|Name                       | Description                                                              |
|---------------------------|--------------------------------------------------------------------------|
|`README.Rmd`, `README.Rmd` |  This file plus generated Markdown                                       |
|                           |                                                                          |
|`Rprofile`                 |  Example Rprofile for use with distcomp for setting up workspace for     |
|                           |  running examples locally with `opencpu` R package                       |
|                           |                                                                          |
|`STCoxSetup.Rout`          |  R Transcript for defining computation, setting up worker sites, and     |
|                           |  master process using shiny apps.                                        |
|`STCoxDefn.rds`            |  The generated definition file for Stratified Cox Example                |
|`STCoxMaster.R`            |  Master R code produced by webapp; see transcript `STCoxSetup.Rout`      |
|`STCoxMaster.Rout`         |  R Transcript executing `STCoxMaster.R`                                  |
|                           |                                                                          |
|`SVDSetup.Rout`            |  R Transcript for defining computation, setting up worker sites, and     |
|                           |  master process using shiny apps.                                        |
|`SVDDefn.rds`              |  The generated definition file for SVD Example                           |
|`SVDMaster.R`              |  Master R code produced by webapp; see transcript `SVDSetup.Rout`        |
|`SVDMaster.Rout`           |  R Transcript executing `SVDMaster.R`                                    |
|                           |                                                                          |
|`svd-example.R`            |  Plain R code for svd example                                            |
|`svd-example.Rout`         |  R Transcript executing `svd-example.R` including all 5 singular values  |
|`svd-site1.csv`            |  Data for Site 1 in svd example                                          |
|`svd-site2.csv`            |  Data for Site 2 in svd example                                          |
|`svd-site3.csv`            |  Data for Site 3 in svd example                                          |
|                           |                                                                          |
|`uis-example.R`            |  Plain R code for uis example                                            |
|`uis-example.Rout`         |  R Transcript executing `uis-example.R`                                  |
|`uis-site1.csv`            |  Data for Site 1 in uis example                                          |
|`uis-site2.csv`            |  Data for Site 2 in uis example                                          |
|`uis.RDS`                  |  UIS data for comparing aggregated results                               |

library(distcomp)

## First we do the conventional thing.

uis <- readRDS("uis.RDS")
coxOrig <- coxph(formula=Surv(time, censor) ~ age + becktota + ndrugfp1 + ndrugfp2 +
                     ivhx3 + race + treat + strata(site), data=uis)
summary(coxOrig)

## We define the computation

coxDef <- data.frame(compType = names(availableComputations())[1],
                     formula = "Surv(time, censor) ~ age + becktota + ndrugfp1 + ndrugfp2 + ivhx3 + race + treat",
                     id = "UIS",
                     stringsAsFactors=FALSE)

library(opencpu)
## We split the data by site
siteData <- with(uis, split(x=uis, f=site))
nSites <- length(siteData)
sites <- lapply(seq.int(nSites),
                function(x) list(name = paste0("site", x),
                                 url = opencpu$url()))

ok <- Map(uploadNewComputation, sites,
          lapply(seq.int(nSites), function(i) coxDef),
          siteData)

stopifnot(all(as.logical(ok)))

master <- CoxMaster$new(defnId = coxDef$id, formula=coxDef$formula)

for (site in sites) {
  master$addSite(name = site$name, url = site$url)
}

result <- master$run()

master$summary()

print(master$summary(), digits=5)

sessionInfo()

shinyServer(function(input, output, session) {


  output$projectSummary <- renderText({
      if(input$printProjectSummary == 0) return()
          isolate({
              paste("Project Summary: ")
          })
    })


  output$name <- renderText({
      if(input$printProjectSummary == 0) return()
        isolate({
        paste("Project name: ", input$nameIn)
      })
    })


  output$desc <- renderText({
    if(input$printProjectSummary == 0) return()
      isolate({
        paste("Description: ", input$descIn)
    })
  })

  output$compType <- renderText({
    if (input$gotoDataInputs ==0 ) return()
    available <- availableComputations()
    availableDesc <- lapply(available, function(x) x$desc)
    chosen <- match(input$compType, availableDesc)
    compType <- names(available)[chosen]
    setComputationInfo("compType", compType)
    setComputationInfo("projectName", input$nameIn)
    setComputationInfo("projectDesc", input$descIn)
    paste(input$compType, "chosen.")
  })

  observe({
    if (input$gotoDataInputs ==0 ) return()
    available <- availableComputations()
    availableDesc <- lapply(available, function(x) x$desc)
    chosen <- match(input$compType, availableDesc)
    compType <- names(available)[chosen]
    setComputationInfo("compType", compType)
    setComputationInfo("projectName", input$nameIn)
    setComputationInfo("projectDesc", input$descIn)
    stopApp(compType)
  })
})

library(distcomp)

print(availableComputations())

svdDef <- data.frame(compType = names(availableComputations())[2],
                     rank = 2L,
                     ncol = 5L,
                     id = "SVD",
                     stringsAsFactors = FALSE)

library(opencpu)

set.seed(12345)

## Three sites
nSites <- 3
siteData <- lapply(seq.int(nSites), function(i) matrix(rnorm(100), nrow=20))
sites <- lapply(seq.int(nSites),
                function(x) list(name = paste0("site", x),
                                 url = opencpu$url()))

## Upload definition
ok <- Map(uploadNewComputation, sites,
          lapply(seq.int(nSites), function(i) svdDef),
          siteData)

stopifnot(all(as.logical(ok)))

##
master <- SVDMaster$new(defnId = svdDef$id, k = svdDef$rank)

for (site in sites) {
  master$addSite(name = site$name, url = site$url)
}

result <- master$run()

print(result)

## Compare with:

x <- do.call(rbind, siteData)

print(result$d)
print(svd(x)$d)

print(result$v)
print(svd(x)$v[, 1:2])

## All  singular values (takes much longer!)
result <- master$run(k=5)
print(result$d)
print(svd(x)$d)

print(result$v)
print(svd(x)$v)


sessionInfo()

library(distcomp)
defn <-
structure(list(id = "46c17593ba8a205f", compType = "StratifiedCoxModel", 
    projectName = "STCoxTest", projectDesc = "Stratified Cox Test", 
    formula = "Surv(time, censor) ~ age + becktota + ndrugfp1 + ndrugfp2 + ivhx3 + race + treat"), .Names = c("id", 
"compType", "projectName", "projectDesc", "formula"), row.names = c(NA, 
-1L), class = "data.frame")
sites <-
list(structure(list(name = "Site1", url = "http://localhost:8109/ocpu"), .Names = c("name", 
"url")), structure(list(name = "Site2", url = "http://localhost:8109/ocpu"), .Names = c("name", 
"url")))
master <- makeMaster(defn)
for (site in sites) {
   master$addSite(name = site$name, url = site$url)
}
result <- master$run()
print(master$summary())

shinyServer(function(input, output, session) {

  output$definitionSummary <- renderPrint({
    if (input$uploadDefinition == 0) return("")
    ## Create data frame from file
    isolate({
      inputFile <- input$definitionFile
      ## shiny::validate(
      ##   need(inputFile != "", "Please select a data set")
      ## )

      available <- availableComputations()

      ## Try to read the RDS fileReturn data frame or error as the case may be
      definition <- tryCatch(
        { readRDS(inputFile$datapath) },
        warning = function(x) x,
        error = function(x) x
      )

      if ( inherits(definition, "error") ||
          !is.data.frame(definition) || is.null(definition$compType) ||
          !(definition$compType %in% names(available)) ) {
        cat("Error! Bad definition file")
      } else {
        for (x in names(definition)) {
          setComputationInfo(x, definition[[x]])
        }
        str(definition)
      }
    })
  })

  output$definitionUploaded <- reactive({
    if (input$uploadDefinition == 0) return()
    ifelse(!is.null(getComputationInfo("id")), "Definition Uploaded; Proceed to specify sites", "")
  })

  output$writeRCode <- reactive({
    if (input$addSite == 0) return()
    ifelse(length(getComputationInfo("siteList")) > 1, "At least two sites added; so can write R code", "")
  })

  output$siteList <- renderPrint({
    if (input$addSite == 0) return()
    isolate({
      name <- stringr::str_trim(input$siteName)
      url <- stringr::str_to_lower(stringr::str_trim(input$ocpuURL))
      shiny::validate(
        need(name != "", "Please enter a non-empty name")
      )
      shiny::validate(
        need(url != "" && grepl("^http", url), "Please enter a URL")
      )

      siteList <- getComputationInfo("siteList")

      shiny::validate(
        need(!(name %in% names(siteList)), paste("Bad site: duplicate name", name))
      )

      n <- length(siteList)
      siteList[[n + 1]] <- list(name = name, url = url)
      setComputationInfo("siteList", siteList)
      str(siteList)
    })
  })

  output$codeSaved <- reactive({
    if (input$saveCode ==0 ) return()
    shiny::validate(
      need(stringr::str_trim(input$outputFile) != "", "Please enter a non-empty name")
    )

    sites <- getComputationInfo("siteList")
    defn <- makeDefinition(getComputationInfo("compType"))
    result <- tryCatch(writeCode(defn, sites, input$outputFile)
                     , error=function(x) x
                     , warning=function(x) x)

    if (inherits(result, "error")) {
      "Error!"
    } else {
      paste("Success: code saved to", input$outputFile)
    }

  })

  observe({
    if (input$exitApp ==0 ) return()
    stopApp(TRUE)
  })

})

library(distcomp)
defn <-
structure(list(id = "a4ed44c4cbd39b0e", compType = "RankKSVD", 
    projectName = "SVDTest", projectDesc = "SVD Test Example", 
    rank = 2L, ncol = 5L), .Names = c("id", "compType", "projectName", 
"projectDesc", "rank", "ncol"), row.names = c(NA, -1L), class = "data.frame")
sites <-
list(structure(list(name = "Site1", url = "http://localhost:8109/ocpu"), .Names = c("name", 
"url")), structure(list(name = "Site2", url = "http://localhost:8109/ocpu"), .Names = c("name", 
"url")), structure(list(name = "Site3", url = "http://localhost:8109/ocpu"), .Names = c("name", 
"url")))
master <- makeMaster(defn)
for (site in sites) {
   master$addSite(name = site$name, url = site$url)
}
result <- master$run()
print(master$summary())

shinyServer(function(input, output, session) {

    createProjectDefinition <- function() {
        data.frame(id = getComputationInfo("id"),
                   compType = getComputationInfo("compType"),
                   projectName = getComputationInfo("projectName"),
                   projectDesc = getComputationInfo("projectDesc"),
                   formula = getComputationInfo("formula"),
                   stringsAsFactors=FALSE)
    }

    observe({
        if (input$exitApp > 0) stopApp(TRUE)
    })

    ## -- End: functions to make tabs active sequentially --

    ## Variables to detect various states the app can be in, depending
    ## on what actions the user has taken.

    ## output$datasetSpecified
    ## output$datasetChecked
    ## output$formulaEntered
    ## output$formulaChecked
    ## output$definitionSaved

    ## When the user chooses a file and clicks on the "Load Data" button
    ## this function is triggered
    output$dataFileContentSummary <- renderPrint({
        if (input$loadData == 0) return("")

        ## Create data frame from source
        isolate({
            if (input$input_type == 'CSV File') {
                inputFile <- input$dataFile
                shiny::validate(
                           need(inputFile != "", "Please select a data set")
                       )
                ## Parse missing value strings
                missingValueIndicators <- stringr::str_trim(scan(textConnection(input$missingIndicators),
                                                                 what = character(0), sep=",", quiet=TRUE))
                ## Return data frame or error as the case may be
                dataResult <- tryCatch(
                { read.csv(file = inputFile$datapath, na.strings = missingValueIndicators) } ,
                warning = function(x) x,
                error = function(x) x
                )
            } else if (input$input_type == 'Redcap API') {
                shiny::validate(
                           need(requireNamespace("redcapAPI", quietly = TRUE), "Please install the redcapAPI package"),
                           need(input$redcapURL != "", "Please enter your Redcap URL"),
                           need(input$redcapToken != "", "Please enter your Redcap Token")
                       )

                dataResult <-tryCatch(
                { redcapAPI::exportRecords(redcapAPI::redcapConnection(url = input$redcapURL, token = input$redcapToken)) },
                warning = function(x) x,
                error = function(x) x
                )
            } else if (input$input_type == 'Postgres') {
                shiny::validate(
                           need(requireNamespace("RPostgreSQL", quietly = TRUE), "Please install the RPostgreSQL package"),
                           need(requireNamespace("dplyr", quietly = TRUE), "Please install the dplyr package"),
                           need(input$dbName != "", "Please enter your Postgres database name"),
                           need(input$dbHost != "", "Please enter your Postgres host"),
                           need(!is.na(as.integer(input$dbPort)), "Please enter your Postgres port number"),
                           need(input$dbUser != "", "Please enter your Postgres database user name"),
                           need(input$dbPassword != "", "Please enter your Postgres database user password"),
                           need(input$dbTable != "", "Please enter your Postgres database table name")
                       )
                dataResult <-  tryCatch(
                {
                    db <- dplyr::src_postgres(dbname = input$dbName, host = input$dbHost, port = input$dbPort,
                                              user = input$dbUser, password = input$dbPassword)
                    ## CAUTION: Need to do better to prevent SQL injection...
                    dplyr::tbl(db, paste("SELECT * from ", input$dbTable))
                },
                warning = function(x) x,
                error = function(x) x
                )
            } else {
                shiny::validate(
                           need(FALSE, "Report bug to Package owner: unexpected Data source!")
                       )
                dataResult <- NULL
            }

            if (is.data.frame(dataResult)){
                setComputationInfo("data", dataResult) ## Store data object
                updateTabsetPanel(session, inputId="navigationList", selected="Sanity Check")
                str(dataResult)
            } else {
                cat('Error!', dataResult$message)
            }
        })
    })

    output$dataLoaded <- reactive({
        if (input$loadData == 0) return()
        ifelse(is.data.frame(getComputationInfo("data")), "Data Loaded; Proceed to Sanity Check", "")
    })

    ## When the user clicks on the "Check Sanity" button
    ## this function is triggered
    output$sanityCheckResult <- reactive({
        if (input$checkSanity == 0) return()
        formula <- getComputationInfo("formula")
        isolate({
            result <- tryCatch(
            {
                CoxWorker$new(defn = createProjectDefinition(), data = getComputationInfo("data"))
            },
            warning = function(x) x,
            error = function(x) x)
            if ("CoxWorker" %in% class(result)) { ## Success
                "Success: data matches formula. Send to Opencpu Server."
            } else {
                paste("Error!", result$message)
            }
        })
    })

    output$populateResult <- renderPrint({
        if (input$populateServer == 0) return()
        isolate({
            shiny::validate(need(input$siteName != "", "Please enter a site name"))
            shiny::validate(need(input$ocpuURL != "", "Please enter an opencpu URL"))
            site <- list(name = input$siteName, url = input$ocpuURL)
            defn <- makeDefinition(getComputationInfo("compType"))
            data <- getComputationInfo("data")
            result <- tryCatch(uploadNewComputation(site=site, defn=defn, data=data),
                               error = function(x) x,
                               warning = function(x) x)
            if (inherits(result, "error") ) {
                "Error: Uploading the definition to server"
            } else {
                ifelse(result, "Success: definition uploaded to server",
                       "Error while uploading definition to server")
            }
        })
    })

})

shinyServer(function(input, output, session) {

    createProjectDefinition <- function() {
        data.frame(id = getComputationInfo("id"),
                   compType = getComputationInfo("compType"),
                   projectName = getComputationInfo("projectName"),
                   projectDesc = getComputationInfo("projectDesc"),
                   he = getComputationInfo("he"),
                   filterCondition = getComputationInfo("filterCondition"),
                   stringsAsFactors=FALSE)
    }

    observe({
        if (input$exitApp > 0) stopApp(TRUE)
    })

    ## -- End: functions to make tabs active sequentially --

    ## Variables to detect various states the app can be in, depending
    ## on what actions the user has taken.

    ## output$datasetSpecified
    ## output$datasetChecked
    ## output$queryConditionEntered
    ## output$definitionSaved

    ## When the user chooses a file or Redcap source or Database source
    ## and clicks on the "Load Data" button this function is triggered
    output$dataFileContentSummary <- renderPrint({
        if (input$loadData == 0) return("")

        ## Create data frame from source
        isolate({
            if (input$input_type == 'CSV File') {
                inputFile <- input$dataFile
                shiny::validate(
                           need(inputFile != "", "Please select a data set")
                       )
                ## Parse missing value strings
                missingValueIndicators <- stringr::str_trim(scan(textConnection(input$missingIndicators),
                                                                 what = character(0), sep=",", quiet=TRUE))
                ## Return data frame or error as the case may be
                dataResult <- tryCatch(
                { read.csv(file = inputFile$datapath, na.strings = missingValueIndicators) } ,
                warning = function(x) x,
                error = function(x) x
                )
            } else if (input$input_type == 'Redcap API') {
                shiny::validate(
                           need(requireNamespace("redcapAPI", quietly = TRUE), "Please install the redcapAPI package"),
                           need(input$redcapURL != "", "Please enter your Redcap URL"),
                           need(input$redcapToken != "", "Please enter your Redcap Token")
                       )

                dataResult <-tryCatch(
                { redcapAPI::exportRecords(redcapAPI::redcapConnection(url = input$redcapURL, token = input$redcapToken)) },
                warning = function(x) x,
                error = function(x) x
                )
            } else if (input$input_type == 'Postgres') {
                shiny::validate(
                           need(requireNamespace("RPostgreSQL", quietly = TRUE), "Please install the RPostgreSQL package"),
                           need(requireNamespace("dplyr", quietly = TRUE), "Please install the dplyr package"),
                           need(input$dbName != "", "Please enter your Postgres database name"),
                           need(input$dbHost != "", "Please enter your Postgres host"),
                           need(!is.na(as.integer(input$dbPort)), "Please enter your Postgres port number"),
                           need(input$dbUser != "", "Please enter your Postgres database user name"),
                           need(input$dbPassword != "", "Please enter your Postgres database user password"),
                           need(input$dbTable != "", "Please enter your Postgres database table name")
                       )
                dataResult <-  tryCatch(
                {
                    db <- dplyr::src_postgres(dbname = input$dbName, host = input$dbHost, port = input$dbPort,
                                              user = input$dbUser, password = input$dbPassword)
                    ## CAUTION: Need to do better to prevent SQL injection...
                    dplyr::tbl(db, paste("SELECT * from ", input$dbTable))
                },
                warning = function(x) x,
                error = function(x) x
                )
            } else {
                shiny::validate(
                           need(FALSE, "Report bug to Package owner: unexpected Data source!")
                       )
                dataResult <- NULL
            }

            if (is.data.frame(dataResult)){
                setComputationInfo("data", dataResult) ## Store data object
                updateTabsetPanel(session, inputId="navigationList", selected="Formula Check")
                str(dataResult)
            } else {
                cat('Error!', dataResult$message)
            }
        })
    })

    output$dataLoaded <- reactive({
        if (input$loadData == 0) return()
        ifelse(is.data.frame(getComputationInfo("data")), "Data loaded; Proceed to Query Condition Check", "")
    })

    ## When the user clicks on the "Check Query Condition" button
    ## this function is triggered
    output$checkQueryConditionResult <- renderPrint({
        if (input$checkQueryCondition == 0) return()
        isolate({
            result <- tryCatch(
            {
                setComputationInfo("filterCondition", input$queryCondition)
                setComputationInfo("id", generateId(list(random = runif(10))))
                QueryCountWorker$new(defn = createProjectDefinition(), data = getComputationInfo("data"))
            },
            warning = function(x) x,
            error = function(x) x)
            if ("QueryCountWorker" %in% class(result)) { ## Success
                sprintf("query condition '%s' is OK!", input$queryCondition)
            } else {
                setComputationInfo("filterCondition", NULL)
                setComputationInfo("id", NULL)
                cat("Error!", result$message)
            }
        })
    })

    output$queryConditionChecked <- reactive({
        if (input$checkQueryCondition == 0) return()
        ifelse(is.null(getComputationInfo("filterCondition")), "", "Query condition checked; Proceed to Output Result")
    })


    output$outputResult <- renderPrint({
        if (input$saveDefinition == 0) return()
        defn <- createProjectDefinition()
        str(defn)
    })

    output$definitionSaved <- reactive({
        if (input$saveDefinition == 0) return()
        defn <- createProjectDefinition()
        ##defnPath <- getConfig()$defnPath
        ##dirName <- paste(defnPath, defn$id, sep=.Platform$file.sep)
        dirName <- getComputationInfo("workingDir")
        fileName <- paste(dirName, input$outputFile, sep=.Platform$file.sep)
        result <- tryCatch(
        {
            ##dir.create(dirName)
            saveRDS(object = defn, file=fileName)
        },
        error = function(x) x)
        if (inherits(result, "error")) {
            paste("Error!", result$message)
        } else {
            paste0("Definition saved to ", input$outputFile)
        }
    })
})

# Distributed Statistical Modeling

author: BN, DLR, SMG, MB, PWL, Stanford University

## Introduction

We demonstrate the possibility of fitting statistical models
stratified by sites in a manner that brings computation to the data
that may be distributed across sites or more generally, partitioned in
some manner. (For simplicity, we will call these partitions, sites.)
The infrastructure consists of a single master process that issues
queries to worker processes running at each of the sites. A query is
merely a function call, more specifically a request to each site to
evaluate a pre-defined function $f(\beta)$ on the data at that site,
for a given value of parameters $\beta$.  The master process uses
these queries to aggregate and execute an optimization algorithm
resulting in a model fit, the results of which should be
_indistinguishable from_ those that might be obtained if all the data
had been in a single place.  Of course, this assumes a lossless
serialization format, like Google Protocol Buffers for example, but we
make do with JSON for now.  Also, in comparisons below, we don't use
exactly the same iterations as the survival package and so minor
differences will be seen.

The advantages are many, chief among them the fact that no raw data
needs to be shared between sites. The modeling entity, however, can
make an unlimited number of queries of the sites, where each query is
a request to compute a model-specific function for a specified value
of parameters. This may pose a security concern that we ignore for
now. However, it leads to some further interesting questions regarding
what may be learned such computation.

We focus specifically on Cox regression models in this exercise.

> [Setup](#setup)

> [A simple example](#simple-example)

>> [A Cox fit on the aggregated data](#simple-example-agg)

>> [The model definition](#simple-model)

>> [The data for each site](#simple-data)

>> [Setting up the sites](#simple-site-setup)

>> [Reproducing original aggregated analysis in a distributed fashion](#reproduce)

> [A larger example](#larger-example)

>> [The aggregated fit] (#larger-example-full)

>> [The distributed fit] (#larger-example-distributed)

> [Bone Marrow Transplant Example](#bmt)

>> [The aggregated fit] (#bmt-full)

>> [The distributed fit] (#bmt-distributed)

> [Byar and Greene Prostate Cancer Data Example (4 strata)](#prostate)


<a id="setup"></a>

### Setup

It must be noted that for users to be able to `knit` this document, or
to run these examples in an R session, an `opencpu` server must be
running with appropriate settings. On MacOS and Unix, this is done by
designating an empty directory as workspace and adding the following
lines to the `${HOME}/.Rprofile`.

```{r, eval=FALSE}
library(distcomp)
distcompSetup(workspace = "full_path_to_workspace_directory",
              ssl_verifyhost = 0L, ssl_verifypeer = 0L)
```

On windows, the same should be done in the `RHOME\etc\Rprofile.site`
file.

__Note__: On Yosemite (MacOS 10.10.4 and below), we have found that
references to `localhost` sometimes fail in the opencpu URL; rather
the explicit IP address `127.0.0.1` is needed.

In what follows, we assume that such initialization profile has been
done. Furthermore, we assume that the `opencpu` server has been
started in the _same session_ as the one where this markdown document
is being knitted via `library(opencpu)`. This is merely a
convenience that allows us to refer to the `opencpu` server URL
programmatically via `opencpu$url()`; otherwise, alternative means
would have to be found to refer to the `opencpu` URL in a permanent
manner. For example, if `opencpu` is started in another terminal using
`library(opencpu)`, one could note down the URL that it displays after
starting, and define

```{r, eval=FALSE}
opencpu <- list(url = function() "your opencpu URL here")
```

to ensure that the expression `opencpu$url()` returns the
appropriate URL.

To summarize: assuming that an `opencpu` server has been started via
`library(opencpu)` with a proper R profile and the expression
`opencpu$url()` has been set up appropriately, one can proceed to knit
this document in that R session.

<a id="simple-example"></a>

## A simple example

We take a simple example from the `survival` package, the `ovarian`
dataset.

```{r}
library(knitr)
library(survival)
data(ovarian)
str(ovarian)
kable(ovarian)
```

<a id="simple-example-agg"></a>

### A Cox fit on the aggregated data

A simple Cox model fit estimates the effect of age on survival,
stratified by drug.

```{r}
cp <- coxph(Surv(futime, fustat) ~ age + strata(rx), data = ovarian, ties = "breslow")
print(cp)
```

The above shows the intial and final log likelihood values at 0 and
the estimated coefficient respectively and the actual estimated
coefficient in the last line.

For our setting, we can pretend that this data set is actually from
two sites, one containing the control or placebo group (`rx = 1`)and
the other containing the drug group (`rx = 2`).

<a id="simple-model"></a>

### The model definition

We first need to define the computation. The available computations
can be listed:
```{r}
print(availableComputations())
```

So, we can define the ovarian data computation as follows.

```{r}
ovarianDef <- data.frame(compType = names(availableComputations())[1],
                         formula = "Surv(futime, fustat) ~ age",
                         id = "Ovarian", stringsAsFactors=FALSE)
```

<a id="simple-data"></a>

### The data for each site

We split the `ovarian` data into two sites as indicated earlier.

```{r}
siteData <- with(ovarian, split(x = ovarian, f = rx))
```

<a id="simple-site-setup"></a>

### Setting up the sites

We can now set up each site with its own data. A site is merely a list
of two items, a (unique) `name` and an `opencpu` URL.

```{r}
nSites <- length(siteData)
sites <- lapply(seq.int(nSites), function(i) list(name = paste0("site", i),
                                                  url = opencpu$url()))
```

By default, on each site, data for a computation is stored under the
name `data.rds` and the definition itself is stored under the name
`defn.rds`.  If the sites are physically separate, then everything
proceeds smoothly. However, here, in our case, we are using the same
`opencpu` server for simulating both sites. We therefore have to save
the files under different names, just for this experiment, say
`site1.rds` and `site2.rds` for this example. This is all taken care
of by the code which checks to see if the `opencpu` URLs refer to
local hosts or not. (In fact, as this code is executing, one can
examine the contents of the workspace to see what is happening)
We now `Map` the upload function to each site so that the computation
becomes well-defined.

```{r}
ok <- Map(uploadNewComputation, sites,
          lapply(seq.int(nSites), function(i) ovarianDef),
          siteData)

stopifnot(all(as.logical(ok)))
```

<a id="reproduce"></a>

### Reproducing original aggregated analysis in a distributed fashion

We are now ready to reproduce the original aggregated analysis. We
first create a master object using the same definition.

```{r}
master <- CoxMaster$new(defnId = ovarianDef$id, formula = ovarianDef$formula)
```
We then add the worker sites specifying a name and a URL for each.
names.

```{r}
for (i in seq.int(nSites)) {
    master$addSite(name = sites[[i]]$name, url = sites[[i]]$url)
}
```
And we now maximize the partial likelihood, by calling the `run`
method of the master.

```{r, results='hide'}
result <- master$run()
```

We then print the summary.

```{r}
master$summary()
```
As we can see, the results we get from the distributed analysis are
the same as we got for the original aggregated analysis. We print them
separately here for comparison.

<a id="larger-example"></a>

## A larger example

We turn to a larger the example from Therneau and Grambsch using the
`pbc` data where the stratifying variable is `ascites`.

<a id="larger-example-full"></a>

### The aggregated fit

```{r}
data(pbc)
pbcCox <- coxph(Surv(time, status==2) ~ age + edema + log(bili) +
                  log(protime) + log(albumin) + strata(ascites), data = pbc,
                ties = "breslow")
print(pbcCox)

```

<a id="larger-example-distributed"></a>

### The distributed fit

We split the data using `ascites` and proceed the usual way as shown above

```{r}
pbcDef <- data.frame(compType = names(availableComputations())[1],
                     formula = paste("Surv(time, status==2) ~ age + edema +",
                       "log(bili) + log(protime) + log(albumin)"),
                     id = "pbc", stringsAsFactors = FALSE)
siteData <- with(pbc, split(x = pbc, f = ascites))
nSites <- length(siteData)
sites <- lapply(seq.int(nSites), function(i) list(name = paste0("site", i),
                                                  url = opencpu$url()))
ok <- Map(uploadNewComputation, sites,
          lapply(seq.int(nSites), function(i) pbcDef),
          siteData)
stopifnot(all(as.logical(ok)))
master <- CoxMaster$new(defnId = pbcDef$id, formula = pbcDef$formula)
for (site in sites) {
    master$addSite(site$name, site$url)
}
```

```{r, results='hide'}
result <- master$run()
```

We then print the summary.

```{r}
kable(master$summary())
```

The results should be comparable to the aggregated fit above.

<a id="bmt"></a>

## Bone Marrow Transplant Example

This uses the `bmt` data from Klein and Moschberger. Some variable
renaming, first.

```{r}
if (!require("KMsurv")) {
  stop("Please install the KMsurv package before proceeding")
}
```

```{r}
##
## BMT data
##

library(KMsurv)
data(bmt)
bmt$tnodis <- bmt$t2 ## time to disease relapse/death
bmt$inodis <- bmt$d3 ## disease relapse/death indicator
bmt$tplate <- bmt$tp ## time to platelet recovery
bmt$iplate <- bmt$dp ## platelet recovery
bmt$agep <- bmt$z1 ## age of patient in years
bmt$aged <- bmt$z2 ## age of donor in years
bmt$fab <- bmt$z8 ## fab grade 4 or 5 + AML
bmt$imtx <- bmt$z10 ## MTX used
bmt <- bmt[order(bmt$tnodis), ] ## order by time to disease relapse/death
bmt <- cbind(1:nrow(bmt)[1], bmt)
names(bmt)[1] <- "id"

##
#####
##
bmt$agep.c <- bmt$agep - 28
bmt$aged.c <- bmt$aged - 28

bmt$imtx <- factor(bmt$imtx)
```

<a id="bmt-full"></a>

### The aggregated fit

```{r}
bmt.cph <- coxph(formula = Surv(tnodis, inodis) ~ fab + agep.c * aged.c +
                 factor(group) + strata(imtx), data = bmt, ties = "breslow")

print(bmt.cph)
```

<a id="bmt-distributed"></a>

### The distributed fit

We'll use `imtx` for splitting data into sites.

```{r}
bmtDef <- data.frame(compType = names(availableComputations())[1],
                     formula = paste("Surv(tnodis, inodis) ~ fab +",
                       "agep.c * aged.c + factor(group)"),
                     id = "bmt", stringsAsFactors = FALSE)
siteData <- with(bmt, split(x = bmt, f = imtx))
nSites <- length(siteData)
sites <- lapply(seq.int(nSites), function(i) list(name = paste0("site", i),
                                                  url = opencpu$url()))
ok <- Map(uploadNewComputation, sites,
          lapply(seq.int(nSites), function(i) bmtDef),
          siteData)

stopifnot(all(as.logical(ok)))
master <- CoxMaster$new(defnId = bmtDef$id, formula = bmtDef$formula)
for (site in sites) {
    master$addSite(site$name, site$url)
}
```

```{r, results='hide'}
result <- master$run()
```

We then print the summary.

```{r}
kable(master$summary())
```

<a id="prostate"></a>

## Byar and Greene Prostate Cancer Data Example

This example is the largest of them all and also has four strata
rather than 2.

```{r}
prostate <- readRDS("prostate.RDS")
```

<a id="prostate-full"></a>

### The aggregated fit

```{r}
pcph <- coxph(Surv(dtime, status) ~ stage + strata(rx) + age + wt + pf + hx +
                  sbp + dbp + ekg + hg + sz + sg + ap + bm, data = prostate)
print(pcph)
```
<a id="prostate-distributed"></a>

### The distributed fit

The distributed fit for this particular example doesn't work in the
current implementation. This is because the $X$ matrix for each site
is singular. The math holds, obviously, but the current implementation
is based on re-using as much of the `survival` package as possible. We
have to work harder to implement the distributed computation in the
situation where $X$ is singular at at least one site. This affects the
computation of the variance (or equivalently, the information
matrix). Some work needs to be done to work around this and figure out
how best to reuse what's already in the `survival` package.

However, in order to demonstrate that the distributed fit really
works, we show below an alternative implementation that yields the
same result as the aggregated one.


<a id="site-object"></a>

#### An object representing the sites

Here's a reference object for each site. It has several fields: a
`data` field containing the data, a `formula` field (as used in the
well-known `survival` R package) describing the model being fit. These
two are the only ones needed for initializing a site. Other fields
that are generated based on these two fields are `modelDataFrame`
containing the actual model data used for fitting the model and a
`modelMatrix`.

```{r}
site <- setRefClass("siteObject",
                    fields = list(
                        data = "data.frame",
                        formula = "formula",
                        modelDataFrame = "data.frame",
                        coxControl = "list",
                        modelMatrix = "matrix"),
                    methods = list(
                        initialize = function(formula, data) {
                            'Initialize the object with a formula and dataset'
                            formula <<- formula
                            data <<- data
                            temp <- coxph.control()
                            temp$iter.max <- 0
                            coxControl <<- temp
                            stopifnot(kosher())
                        },
                        kosher = function() {
                            'Check that the class data passes sanity checks'
                            modelDataFrame <<- model.frame(formula, data = data)
                            lhs <- modelDataFrame[, 1]
                            ordering <- order(lhs[, 1])
                            modelDataFrame <<- modelDataFrame[ordering, ]
                            data <<- data[ordering, ]
                            modelMatrix <<- model.matrix(formula, data = modelDataFrame)
                            TRUE
                        },
                        dimP = function() {
                            'Return the number of covariates'
                            ncol(modelMatrix) - 1
                        })
                    )
site$accessors(c("data", "formula", "modelDataFrame", "modelMatrix"))
```

The `initialize` method above mostly sets the fields, generates values
for other fields, and does a mild sanity check. It will not proceed
further if the function `kosher` returns false.  For now the `kosher`
function merely orders the data frame by follow-up time, but in a
production system a number of other checks might be performed, such as
ensuring all named variables are available at the site.

The method `dimP` merely returns the number of columns of the model
matrix.

<a id="site-loglik"></a>

### The (partial) log likelihood function for each site

For our example, the (partial) log likelihood (named `localLogLik`) is simple
and can be computed directly. Assuming failure times $t_i$ and
event indicators $\delta_i$, it is
precisely:
$$
l(\beta) = \sum_{i=1}^n\delta_i\biggl[z_i\beta -\log\bigl(\sum_{j\in R(t_i)} \exp(z_j\beta)\bigr)\biggr]
$$
where $\beta$ is the vector of parameters, $z_i$ is row $i$ of the
model matrix (covariates for subject $i$) and $R(t_i)$ is the risk set
at time $t_i$.

The first derivative with respect to $\beta$ is:
$$
l'(\beta) = Z^T\delta - \sum_{i=1}^n\delta_i\frac{\sum_{j\in R(t_i)} \exp(z_j\beta)z_j^T}{\sum_{j\in R(t_i)} \exp(z_j\beta)}.
$$

```{r}
localLogLik <- function(beta) {
    beta <- c(0, beta) ## model matrix has intercept in model
    z <- modelMatrix
    delta <- modelDataFrame[, 1][, 2] ## event indicators
    zBeta <- z %*% beta
    sum.exp.zBeta <- rev(cumsum(rev(exp(zBeta))))
    ld <- delta %*% (z  - apply(diag(as.numeric(zBeta)) %*% z, 2, function(x) rev(cumsum(rev(x)))) / sum.exp.zBeta)
    result <- sum(delta * (zBeta - log(sum.exp.zBeta))) # assuming Breslow
    attr(result, "gradient") <- ld
    result
}
site$methods(logLik = localLogLik)
```

#### The alternative distributed fit.

We are now ready to do the alternative distributed fit. We split the
`prostate` data into two sites as indicated earlier.

```{r}
siteData <- with(prostate, split(x = prostate, f = rx))
sites <- lapply(siteData,
                function(x) {
                    site$new(data = x,
                             formula = Surv(dtime, status) ~ stage + age + wt + pf + hx + sbp + dbp + ekg + hg + sz + sg + ap + bm)
                })
```
Ok, now we can reproduce the original aggregated analysis by writing a
full likelihood routine.

```{r}
logLik <- function(beta, sites) {
    sum(sapply(sites, function(x) x$logLik(beta)))
}
```

All that remains is to maximize this log likelihood.

```{r}
mleResults <- nlm(f=function(x) -logLik(x, sites),
                  p = rep(0, sites[[1]]$dimP()),
                  gradtol = 1e-10, iterlim = 1000)
```

We print the coefficient estimates side-by-side for comparison.

```{r}
d <- data.frame(distCoef = mleResults$estimate, aggCoef = pcph$coefficients)
rownames(d) <- names(pcph$coefficients)
kable(d)
```

## Session Information
```{r}
sessionInfo()
```

---
title: "Prototyping Distributed Computations"
author: "Balasubramanian Narasimhan"
date: '`r Sys.Date()`'
output:
  html_document:
  fig_caption: yes
  theme: cerulean
  toc: yes
  toc_depth: 2
vignette: >
  %\VignetteIndexEntry{Prototyping Distributed Computations}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---

```{r echo=FALSE}
knitr::opts_chunk$set(
    message = FALSE,
    warning = FALSE,
    error = FALSE,
    tidy = FALSE,
    cache = FALSE
)
suppressMessages(suppressWarnings(library(distcomp)))
dcWorkspace <- tempdir()
ignore <- distcompSetup(workspace = dcWorkspace,
                        ssl_verifyhost = 0L, ssl_verifypeer = 0L)
```

## Introduction

The `distcomp` package allows one to perform computations on data that
is row-partitioned data among several sites. Implemented methods
include stratified Cox regression and singular value decomposition
(SVD).  The distributed computations rely on a REST API for R, such as
that provided by [Opencpu](https://www.opencpu.org) for example.

In order to prototype new methods for `distcomp`, it is convenient to
write code that does all computations locally, at least during the
development phase. This allows for easy debugging and code
changes. The step to using a REST call is merely one step off.  For
example, in the context of distributed multiple imputation, the
distributed SVD is a building block. So one has to be able to be able
to run the svd operation not only in a modular fashion, but also
quickly to test code.  

Previous versions of `distcomp` assumed all computations were done
using `opencpu` remote calls. This meant that the results were
time-consuming to check; for reasonably sized problems one would have
to wait for hours.

Version 1.1 of `distcomp` addresses this by allowing local
computations, in essence _faking_ the `opencpu` calls. All
calculations are done locally at normal speeds (rather than a https
`POST` request) while ensuring that the sites are only privy to their
own data. 

## An Example

```{r}
available <- availableComputations()
( computationNames <- names(available) )
```

We will perform an SVD on a 1500 by 20 matrix where the matrix is
distributed across three sites each having a 500 by 20 matrix.  We will
extract the first 10 components using this distributed algorithm.

We first define the computation.

```{r}
svdDef <- data.frame(compType = computationNames[2],
                     rank = 20L,
                     ncol = 20L,
                     id = "SVD",
                     stringsAsFactors = FALSE)
```

We generate some synthetic data.

```{r}
set.seed(12345)
## Three sites
nSites <- 3
siteData <- lapply(seq.int(nSites), function(i) matrix(rnorm(10000), ncol=20))
```

We now create local objects to represent the sites, a list of three
items, each with a name and its specific data.

```{r}
sites <- lapply(seq.int(nSites),
                function(x) list(name = paste0("site", x),
                                 worker = makeWorker(defn = svdDef, data = siteData[[x]])
                                 ))
```

We are now ready to create a master object and add sites to it.

```{r}
master <- makeMaster(svdDef)
for (site in sites) {
  master$addSite(name = site$name, worker = site$worker)
}
```

When any of the sites specify a `worker` argument in the call to
`addSite`, it is an indication that the computation is to be performed
locally. Otherwise, a URL will have to be specified using the `url`
argument to `addSite`. (Only one of `worker` or `url` can be
specified.) 

Finally, we are ready to run the decomposition, specifying a maximum
number of iterations, so that things don't go haywire.  This takes
less than 5 seconds on my laptop. 

```{r}
system.time(result <- master$run(max.iter = 10000))
```

The result is a named list of two things, the $d$ diagonal values and the
$v$ matrix.

We can compare the results obtained here with the actual.

```{r}
full_data <- do.call(rbind, siteData)
full_svd <- svd(full_data)
```

Let's print it side-by-side.

```{r}
d_table <- data.frame(truth = full_svd$d, distcomp = result$d)
knitr::kable(d_table)
```

We can also compare the $v$ matrix, taking into account the signs may
be different.

```{r}
norm(abs(result$v) - abs(full_svd$v), "F")
```

## Stratified Cox Model

The approach for the stratified Cox model is similar. We start with a definition.

```{r}
coxDef <- data.frame(compType = computationNames[1],
                     formula = "Surv(time, censor) ~ age + becktota + ndrugfp1 + ndrugfp2 + ivhx3 + race + treat",
                     projectName = "STCoxTest",
                     projectDesc = "STCox Project Desc",
                     stringsAsFactors = FALSE)
```

We now create two sites with appropriate data

```{r}
## Two sites
siteDataFiles <- file.path(system.file("ex", package="distcomp"), c("uis-site1.csv", "uis-site2.csv"))
siteData <- lapply(siteDataFiles, read.csv)
```

We now create local objects to represent the two sites, each with a
name and its specific data.

```{r}
sites <- lapply(seq_along(siteData),
                function(x) list(name = paste0("site", x),
                                 worker = makeWorker(defn = coxDef, data = siteData[[x]])
                                 ))
```

We are now ready to create a master object and add sites to it.

```{r}
master <- makeMaster(coxDef)
for (site in sites) {
  master$addSite(name = site$name, worker = site$worker)
}
```

Now we can run the model.

```{r, }
result <- master$run()
print(master$summary(), digits = 4)
```

The above result will be the same as what we obtain from a Cox
regression fit. 

```{r}
coxFit <- survival::coxph(formula=Surv(time, censor) ~ age + becktota + ndrugfp1 + ndrugfp2 +
                              ivhx3 + race + treat + strata(site),
                          data = rbind(siteData[[1]], siteData[[2]]))
summary(coxFit)$coefficients
```

## Session Info

```{r}
sessionInfo()
```
